#
#  This file is part of MUMPS 4.8.4, built on Mon Dec 15 15:31:38 UTC 2008
#
#Begin orderings

# NOTE that PORD is distributed within MUMPS by default. If you would like to
# use other orderings, you need to obtain the corresponding package and modify
# the variables below accordingly.
# For example, to have Metis available within MUMPS:
#          1/ download Metis and compile it
#          2/ uncomment (suppress # in first column) lines
#             starting with LMETISDIR,  LMETIS
#          3/ add -Dmetis in line ORDERINGSF
#             ORDERINGSF  = -Dpord -Dmetis
#          4/ Compile and install MUMPS
#             make clean; make   (to clean up previous installation)
#
#          Metis is now available as an internal ordering for MUMPS.
#

LSCOTCHDIR = ${LIBEXECDIR}/pastix/lib
LSCOTCH   = -L$(LSCOTCHDIR) -lesmumps -lfax -lsymbol -ldof -lorder -lscotch -lscotcherr -lcommon #-lm

LPORDDIR = $(topdir)/PORD/lib/
IPORD    = -I$(topdir)/PORD/include/
LPORD    = -L$(LPORDDIR) -lpord

LMETISDIR = ${LIBDIR}
#IMETIS    = # Metis doesn't need include files (Fortran interface avail.)
LMETIS    = -L$(LMETISDIR) -lmetis

# The following variables will be used in the compilation process.
ORDERINGSF = -Dscotch -Dmetis -Dpord
#ORDERINGSF  = -Dpord
ORDERINGSC  = $(ORDERINGSF)
LORDERINGS = $(LMETIS) $(LPORD) $(LSCOTCH)
IORDERINGS = $(IMETIS) $(IPORD) $(ISCOTCH)

#End orderings
########################################################################
################################################################################

PLAT    =
RM = /bin/rm -f
CC = mpicc
FC = mpif90
FL = mpif90
AR = ar vr
RANLIB = ranlib
#RANLIB  = echo
SCALAP  = -lscalapack -lblacs -larpack_LINUX
#INCPAR = -I/usr/local/include
INCPAR = -I${MPIDIR}/include
LIBPAR = $(SCALAP)  -L${MPIDIR}/lib/ -lmpi_f77 -lmpi -lutil -ldl -lpthread -Wl,-R${MPIDIR}/lib
#LIBPAR = $(SCALAP)  -L/usr/local/mpich/lib/ -lmpich 
# See point 17 in the FAQ to have more details on the compilation of mpich with gfortran
INCSEQ = -I$(topdir)/libseq
LIBSEQ  =  -L$(topdir)/libseq -lmpiseq
LIBBLAS = -lf77blas -latlas
#LIBBLAS = -L/local/BLAS -lblas
LIBOTHERS = -lpthread
#Preprocessor defs for calling Fortran from C (-DAdd_ or -DAdd__ or -DUPPER)
CDEFS   = -DAdd_

#Begin Optimized options
OPTF    = -pipe -O2 -Wall -fPIC -DPIC -Dintel_ -DALLOW_NON_INIT 
OPTL    = -pipe -O2 -Wall -fPIC -DPIC
OPTC    = -pipe -O2 -Wall -fPIC -DPIC
OPTFLAGS = $(OPTC)
#End Optimized options
INC = $(INCPAR)
LIB = $(LIBPAR)
LIBSEQNEEDED =
